#include "../include/gbSprite.hpp"

namespace GhulbusGraphics {
#ifdef _GHULBUSGRAPHICS__USE_D3D9_

	gbSprite_D3D9::gbSprite_D3D9(LPD3DXSPRITE sprite, gbTexture_D3D9* texture)
		:m_lpSprite(sprite)
	{
		m_texture = texture;

	}
	gbSprite_D3D9::~gbSprite_D3D9() {
		if(m_texture) { delete m_texture; }
	}
	void gbSprite_D3D9::Render() {
		HRESULT hres;
		D3DXVECTOR3 pos( m_position.GetX(), m_position.GetY(), m_position.GetZ() );
		LPDIRECT3DTEXTURE9 lpTex = dynamic_cast<gbTexture_D3D9*>(m_texture)->GetD3D9Texture();
		hres = m_lpSprite->Begin(D3DXSPRITE_ALPHABLEND);
		hres |= m_lpSprite->Draw(lpTex, NULL, NULL, &pos, 0xFFFFFFFF);
		hres |= m_lpSprite->End();
		if(hres != D3D_OK) {
			throw( Ghulbus::gbException( Ghulbus::gbException::GB_FAILED,
										 "Error while drawing d3d sprite" ) );
		}
	}
	void gbSprite_D3D9::Release() {
		if(m_texture->IsLocked()) {
			m_texture->UnlockTexture();
		}
		dynamic_cast<gbTexture_D3D9*>(m_texture)->GetD3D9Texture()->Release();
		m_lpSprite->Release();
		delete this;
	}

#endif
}

