extern "C" {
	#include "lua.h"
	#include "lauxlib.h"
	#include "lualib.h"
}
#include "resource.h"
#include "gbLib/include/gbGraphics.hpp"
#include "gbLib/include/gb2D.hpp"
#include "gbLib/include/gbTurtle.hpp"

void MainLoop();	//display loop for gb2d

//Declaration of turtle.* interface functions
int lturtle_Init(int, int, bool);
int lturtle_Hello(lua_State* L);
int lturtle_Go(lua_State* L);
int lturtle_TurnLeft(lua_State* L);
int lturtle_TurnRight(lua_State* L);
int lturtle_Reset(lua_State* L);
int lturtle_Show(lua_State* L);
int lturtle_Goto(lua_State* L);
int lturtle_SetAngle(lua_State* L);
int lturtle_PenDown(lua_State* L);
int lturtle_PenUp(lua_State* L);
int lturtle_PenToggle(lua_State* L);
int lturtle_SetColor(lua_State* L);
//Map of turtle.* functions (partially localized)
static const struct luaL_reg lturtlelib[] = {
	{"Go",			   lturtle_Go},
	{"TurnLeft",       lturtle_TurnLeft},
	{"TurnRight",      lturtle_TurnRight},
	{"Reset",          lturtle_Reset},
	{"Show",           lturtle_Show},
	{"Goto",           lturtle_Goto},
	{"PenDown",        lturtle_PenDown},
	{"PenUp",          lturtle_PenUp},
	{"PenToggle",      lturtle_PenToggle},
	{"SetColor",	   lturtle_SetColor},
	{"SetAngle",       lturtle_SetAngle},
	{"vorwaerts",      lturtle_Go},
	{"links",          lturtle_TurnLeft},
	{"rechts",         lturtle_TurnRight},
	{"gehezu",         lturtle_Goto},
	{"drehezu",        lturtle_SetAngle},
	{"stifthoch",      lturtle_PenUp},
	{"stiftab",        lturtle_PenDown},
	{"stiftfarbe",     lturtle_SetColor},
	{"anfang",         lturtle_Reset},
	{"HelloTurtle",    lturtle_Hello},
	{NULL, NULL}
};

//Library loader for lturtle:
LUALIB_API int luaopen_turtle(lua_State* L);

void openstdlibs (lua_State *l);	//Loader for lua-stdlibs
const luaL_reg lualibs[] = {		//Map for stdlibs
  {"", luaopen_base},
  {LUA_LOADLIBNAME, luaopen_package},
  {LUA_TABLIBNAME, luaopen_table},
  {LUA_IOLIBNAME, luaopen_io},
  {LUA_OSLIBNAME, luaopen_os},
  {LUA_STRLIBNAME, luaopen_string},
  {LUA_MATHLIBNAME, luaopen_math},
  {LUA_DBLIBNAME, luaopen_debug},
  {"turtle", luaopen_turtle},
  {NULL, NULL}
};

